#!/usr/bin/python
import sys, pygame, random, math, os, getpass 
from pygame.locals import *
import urllib

pygame.init()

# nejake konstanty

show_splash = 0
field_minx, field_maxx, field_miny, field_maxy = 20, 460, 20, 460

level_definitions = [ [], [1,0,0], [2,0,0], [3,0,0], [0,1,0], [1,1,0], [2,1,0], [0,0,1],
 [2,0,1], [0,1,1], [3,1,0], [3,0,1], [4,1,0], [0,0,2], [2,1,1], [2,10,0], [2,0,2], 
 [8,0,0], [1,0,3], [5,0,2], [6,1,1], [0,0,4], [11,0,0], [4,2,2], [0,1,4], [7,2,2],
 [14,0,0] ]

font = pygame.font.Font(None, 24)
bigfont = pygame.font.Font(None, 48)

# inicializacia globalnych premennych

VERSION = "1.6"
playing = 0
wakeup_flag = 0
invincible_ticks = 0
SCORE = 0
LIVES = 0
LEVEL = 0
players_name = ''

##### finish(): slusne skonci beh programu ############################ {{{
def finish():
    pygame.mouse.set_visible(1)
    pygame.event.set_grab(0)
    sys.exit()
##### }}}

##### {show,hide}_player(): {schova,ukaze} hraca ###################### {{{
def hide_player(): 
    if invincible_ticks>0: 
        fading_rect.center = player_rect.center
        screen.blit(background, fading_rect, fading_rect)
    else:
        screen.blit(background, player_rect, player_rect)
def show_player(): 
    if invincible_ticks>0:
        numero = (invincible_ticks+5) / 14
        fading_rect.center = player_rect.center
        screen.blit(fading_player[numero], fading_rect )
        last_player_rect = fading_rect
    else:
        screen.blit(normal_player, player_rect)
        last_player_rect = player_rect
##### }}}
##### {show,hide,move}_enemies(): kresli nepriatelov a hybe nimi ###### {{{
def show_enemies():
    for i in range(len(enemies)):
        for e in enemies[i]:
            screen.blit(enemy_pics[i], enemy_rects[i].move(e) )

def hide_enemies():
    for i in range(len(enemies)):
        for e in enemies[i]:
            screen.blit(background, enemy_rects[i].move(e), enemy_rects[i].move(e) )

def move_enemies():
    hide_player()
    hide_enemies()
    for i in range(len(enemies)):
        for j in range(len(enemies[i])):
            x,y = enemies_real[i][j]
            dx,dy = enemy_directions[i][j]
            if i==1 or (i==2 and random.randint(0,30)==0):
                # homing missile
                ex,ey = enemies_real[i][j]
                dx,dy = player_rect.center
                dx -= ex
                dy -= ey
                dlen = math.sqrt(dx*dx + dy*dy)
                dx /= dlen
                dy /= dlen
                dx *= 3+2*i
                dy *= 3+2*i
            lx,ly = enemy_rects[i].size
            if (x+dx+lx > field_maxx or x+dx < field_minx): dx = -dx
            if (y+dy+ly > field_maxy or y+dy < field_miny): dy = -dy
            enemies_real[i][j] = (x+dx,y+dy)
            enemies[i][j] = (int(x+dx),int(y+dy))
            enemy_directions[i][j] = (dx,dy)
    show_enemies()
    if playing==1: show_player()
    pygame.display.flip()
##### }}}
##### clip_player(): oreze pohyb hraca na hraci plan ################## {{{
def clip_player():
    global player_rect
    zmena = 0
    if player_rect.left < field_minx:    
        player_rect.left = field_minx
        zmena = 1
    if player_rect.right > field_maxx:   
        player_rect.right = field_maxx
        zmena = 1
    if player_rect.top < field_miny:     
        player_rect.top = field_miny
        zmena = 1
    if player_rect.bottom > field_maxy:  
        player_rect.bottom = field_maxy
        zmena = 1
    if zmena:
        pygame.mouse.set_pos(player_rect.centerx, player_rect.centery)
##### }}}
##### show_score(): vypis aktualneho skore ############################ {{{
def show_score():
    global SCORE
    textcolor = 200, 75, 0
    background.blit(original_background, score_rect, score_rect)
    # napis
    text = font.render("SCORE:", 1, textcolor)
    textrect = text.get_rect()
    x = score_rect.left + 5
    y = score_rect.top + (score_rect.height-textrect.height)/2
    background.blit(text, textrect.move(x,y) )
    # cislo
    text = font.render(str(SCORE), 1, textcolor)
    textrect = text.get_rect()
    x = score_rect.right - textrect.width - 5
    y = score_rect.top + (score_rect.height-textrect.height)/2
    background.blit(text, textrect.move(x,y) )
    # output
    screen.blit(background, score_rect, score_rect)
    pygame.display.flip()
##### }}}
##### show_lives(): vypis aktualneho poctu zivotov ############################ {{{
def show_lives():
    global LIVES
    textcolor = 200, 75, 0
    background.blit(original_background, lives_rect, lives_rect)
    # napis
    text = font.render("LIVES:", 1, textcolor)
    textrect = text.get_rect()
    x = lives_rect.left + 5
    y = lives_rect.top + (lives_rect.height-textrect.height)/2
    background.blit(text, textrect.move(x,y) )
    # cislo
    for i in range(LIVES):
        x = lives_rect.right - player_rect.width - 5 - 20*i
        y = lives_rect.top
        background.blit(normal_player, (x,y))
    # output
    screen.blit(background, lives_rect, lives_rect)
    pygame.display.flip()
##### }}}

##### upload_score(): nahra skore na nas server ####################### {{{
def upload_score():
    data = {}
    data['score'] = SCORE
    data['name'] = players_name.encode('utf-8')
    data['version'] = VERSION
    urldata = urllib.urlencode(data);
    try:
        url = urllib.urlopen("http://ksp.sk/~misof/arkticka_vos/write_score.phpu?"+urldata)
        url.close()
    except:
        print "Nepodarilo sa uploadnut skore."
    pygame.event.clear() # co sa nam nahromadilo za cakanie to odignorujeme
##### }}}
##### get_players_name(): nacita meno hraca ########################### {{{
def get_players_name():
    gnbackground = pygame.image.load("getname.png")
    screen.blit(gnbackground, (0,0))
    pygame.display.flip()

    try:
        name = getpass.getuser()
    except:
        name = ""
    touched = 0
    delta = (105,170)
    graycolor = 75, 75, 75
    textcolor = 0, 75, 200
    
    text = bigfont.render(name+"_", 1, graycolor)
    screen.blit(text,text.get_rect().move(delta))
    pygame.display.flip()
    
    while 1:
        # get input
        for event in pygame.event.get():
            if event.type == QUIT: sys.exit(0)
            elif event.type == KEYDOWN:
                text = bigfont.render(name+"_", 1, textcolor)
                screen.blit(gnbackground,text.get_rect().move(delta),text.get_rect().move(delta))
                
                if event.key == K_ESCAPE: sys.exit(0)
                elif event.key in [ K_KP_ENTER, K_RETURN ]: return name
                elif event.key == 8:
                    if len(name)>0: name = name[0:len(name)-1]
                else: 
                    if event.key in [ K_UP, K_DOWN, K_RIGHT, K_LEFT ]: touched=1
                    if touched==0:
                        name = event.unicode
                    else:
                        name += event.unicode
                
                touched = 1
                text = bigfont.render(name+"_", 1, textcolor)
                screen.blit(text,text.get_rect().move(delta))
                pygame.display.flip()

    return "misof" # shouldn't be reachable
##### }}}
##### change_game_state(): zmen stav hry [nic/hra/pauza] ############## {{{
def change_game_state(new_state):
    global playing, SCORE, LIVES, LEVEL, background
    background = pygame.image.load("back640.png")
    if new_state==0: # cancel/end game
        # save score
        if SCORE > 0: upload_score()
        # change things
        playing = 0
        pygame.mouse.set_visible(1)
        pygame.event.set_grab(0)
        # alter background
        textcolor = 0, 75, 200
        text = bigfont.render("GAME OVER", 1, textcolor)
        textrect = text.get_rect()
        textrect.centerx = (field_maxx + field_minx) / 2
        textrect.centery = (field_maxy + field_miny) / 2
        background.blit( text, textrect )
        init_level(10,[5])
        hide_player()
    if new_state==1: # start/resume game
        if playing==0:
            SCORE = 0
            LIVES = 3
            LEVEL = 1
            init_level(10,level_definitions[LEVEL])
        else:
            pygame.mouse.set_pos(player_rect.centerx, player_rect.centery)
            wakeup_flag=1
            for j in range(len(diamonds)): 
                if not diamond_eaten[j]: 
                    background.blit(diamond, diamond_rect.move( diamonds[j])) 
        playing = 1
        pygame.mouse.set_visible(0)
        pygame.event.set_grab(1)
    if new_state==2: # pause game
        playing = 2
        pygame.mouse.set_visible(1)
        pygame.event.set_grab(0)
##### }}}
##### handle_intersections(): riesi ak sa nieco narazilo ############## {{{
def handle_intersections():
    global diamonds_left, SCORE, LIVES, LEVEL, playing, invincible_ticks
    if invincible_ticks > 0: return
    for i in range(len(enemies)):
        for e in enemies[i]:
            totoRect = enemy_rects[i].move( e )
            if totoRect.colliderect( player_rect.inflate(-8,-8) ):
                pygame.time.wait(500)
                pygame.event.clear() # co sa nam nahromadilo za cakanie to odignorujeme
                pygame.mouse.set_pos(player_rect.centerx, player_rect.centery)
                # sem ide efekt
                LIVES -= 1
                show_lives()
                if LIVES==0: 
                    change_game_state(0)
                else:
                    invincible_ticks = 100
                return
    for i in range(len(diamonds)):
        totoRect = diamond_rect.move( diamonds[i] )
        if (not diamond_eaten[i]) and totoRect.colliderect( player_rect.inflate(-8,-8) ):
            diamond_eaten[i] = 1
            hide_player()
            hide_enemies()
            screen.blit( original_background, diamond_rect.move( diamonds[i] ), diamond_rect.move( diamonds[i] ) )
            background.blit( original_background, diamond_rect.move( diamonds[i] ), diamond_rect.move( diamonds[i] ) )
            for j in range(len(diamonds)): 
                if not diamond_eaten[j]: 
                    screen.blit(diamond, diamond_rect.move( diamonds[j]))
                    background.blit(diamond, diamond_rect.move( diamonds[j])) 
            show_enemies()
            show_player()
            pygame.display.flip()
            diamonds_left -= 1
            SCORE += 1
            show_score()
            if (diamonds_left == 0):
                LEVEL += 1
                if LEVEL < len(level_definitions):
                    init_level(10,level_definitions[LEVEL])
                else:
                    # 27 a viac
                    if (LEVEL % 3 == 0):
                        init_level(10, [LEVEL-15,1,1] )
                    elif (LEVEL % 3 == 1):
                        init_level(10, [LEVEL-18,2,2] )
                    else:
                        init_level(10, [LEVEL-12,0,0] )
##### }}}
##### init_level(): nastavi vsetko aby sa dalo hrat ################### {{{
def init_level(diamond_count, enemy_counts):
    global background
    # background = pygame.image.load("back640.png")
    global diamonds, diamond_eaten, diamonds_left, enemies, enemies_real, enemy_directions, invincible_ticks
    # place diamonds:
    diamonds = []
    diamond_eaten = []
    for i in range(diamond_count):
        x = random.randint(field_minx+5,field_maxx-diamond_rect.width-5)
        y = random.randint(field_miny+5,field_maxy-diamond_rect.height-5)
        diamonds.append( (x,y) )
        diamond_eaten.append( 0 )
    diamonds_left = diamond_count
    # place enemies:
    enemies = []
    enemies_real = []
    enemy_directions = []
    for i in range(len(enemy_counts)):
        a = []
        b = []
        c = []
        enemies.append(a)
        enemies_real.append(b)
        enemy_directions.append(c)
        for j in range(enemy_counts[i]):
            x = random.randint(field_minx+10,field_maxx-enemy_rects[i].width-10)
            y = random.randint(field_miny+10,field_maxy-enemy_rects[i].height-10)
            enemies[i].append( (x,y) )
            enemies_real[i].append( (x,y) )
            enemy_directions[i].append( ( random.uniform(-5-3*i,5+3*i), random.uniform(-5-3*i,5+3*i) ) )
    # place the player
    player_rect.center = ( (field_minx+field_maxx)/2, (field_miny+field_maxy)/2 )
    pygame.mouse.set_pos(player_rect.centerx, player_rect.centery)
    wakeup_flag = 1
    # draw the level
    for i in range(len(diamonds)):
        background.blit(diamond, diamond_rect.move( diamonds[i]))
    screen.blit(background,(0,0))
    show_enemies()
    invincible_ticks = 100
    hide_player()
    show_player()
    pygame.display.flip()
    # start the timer, grab the mouse, GO!
    # pygame.mouse.set_visible(0)
    # pygame.event.set_grab(1)
    show_score()
    show_lives()
##### }}}

##### read_config(): nacita premenne z .vosrc ######################### {{{
def read_config():
    global players_name
    try:
        f = open('.vosrc','r')
    except:
        try:
            f = open('vosrc.txt','r')
        except:
            return
    file = f.readlines()
    for line in file:
        pair = line.split('=',1)
        if len(pair)!=2: continue
        param, value = pair[0].strip(), pair[1].strip(' \n')
        if param=='name': players_name = value
##### }}}

##### main() ########################################################## {{{
def main():
    global screen
    global player, normal_player, fading_player, enemy_pics, diamond
    global players_name
    global background, original_background
    global player_rect, fading_rect, last_player_rect, enemy_rects, diamond_rect, score_rect, lives_rect
    global invincible_ticks, wakeup_flag

    # otvorime si okno
    size = width, height = 640, 480
    screen = pygame.display.set_mode(size)
    pygame.display.set_caption("Arkticka vos -- tak jej pomoz!")

    # ukazeme splash screen, pochvalime pygame, aky je skvely
    if show_splash:
        splash = pygame.image.load("pygame_logo.png")
        screen.fill((0,0,0))
        screen.blit(splash, (0,100))
        pygame.display.flip()
        pygame.time.delay(2000)

    # nastavenie casovaca
    global_timer = pygame.USEREVENT
    pygame.time.set_timer(global_timer, 20)

    # nacitanie konfiguracie, mena hraca
    read_config()
    if players_name=='': players_name = get_players_name()

    # nacitanie obrazkov do pamate
    background = pygame.image.load("back640.png")
    original_background = pygame.image.load("back640.png")
    
    normal_player = pygame.image.load("arkticka.png")
    player = normal_player
    player_rect = player.get_rect()
    ### player_rect = player_rect.move( [280,200] )
    
    fading_player = []
    for i in range(1,9): fading_player.append( pygame.image.load("invincible"+str(i)+".png") )
    fading_rect = fading_player[0].get_rect()
    last_player_rect = player_rect
    
    diamond = pygame.image.load("diamond.png")
    diamond_rect = diamond.get_rect()
    
    enemy_pics = []
    for i in range(1,4): enemy_pics.append( pygame.image.load("bad"+str(i)+".png") )
    enemy_rects = []
    for i in enemy_pics: enemy_rects.append( i.get_rect() )

    score_rect = pygame.Rect(475,20,150,40)
    lives_rect = pygame.Rect(475,60,150,player_rect.height)
    
    # a ideme hrat
    screen.blit(background, (0,0))
    pygame.display.flip()
    change_game_state(0)
    mc=0
    
    while 1:
        for event in pygame.event.get():
            if event.type == pygame.QUIT: finish()
            elif event.type == global_timer:
                if playing==1 and invincible_ticks>0: 
                    invincible_ticks -= 1
                    if invincible_ticks==0:
                        hide_player()
                        show_player()
                        pygame.display.flip()
                if playing==0:
                    move_enemies()
                if playing==1:
                    move_enemies()
                    pygame.display.flip()
                    if invincible_ticks==0:
                        handle_intersections()
            elif event.type == MOUSEMOTION:
                mc+=1
                if mc==2:
                    mc=0
                    hide_player()
                    hide_enemies()
                    x,y=event.pos
                    if wakeup_flag:
                        x,y = player_rect.center
                        wakeup_flag = 0
                    if playing==1: 
                        player_rect.centerx,player_rect.centery = x,y
                        clip_player()
                    show_enemies()
                    if playing>0: show_player()
                    pygame.display.flip()
            elif event.type == KEYDOWN:
                if event.key == K_ESCAPE: 
                    if playing==1: change_game_state(0)
                    else: finish()
                if (event.key == 83 or event.key == 115) and (playing==0): change_game_state(1) # S 
                if (event.key == 80 or event.key == 112) and (playing>0): change_game_state(3-playing) # P
##### }}}

if __name__ == '__main__': main()

# vim: fdm=marker:tw=0:nowrap
